<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Dynamics_RegularDriving &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Dynamics_Scenario" href="dynamics_scenario.html" />
    <link rel="prev" title="Driver" href="driver.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Dynamics_RegularDriving</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/dynamics_regular_driving.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="dynamics-regulardriving">
<span id="dynamics-regular-driving"></span><h1>Dynamics_RegularDriving<a class="headerlink" href="#dynamics-regulardriving" title="Link to this heading"></a></h1>
<p>This module is responsible for the vehicle dynamics under normal driving conditions.
It receives a signal from the lateral dynamics module <a class="reference internal" href="algorithm_lateral.html#algorithm-lateral"><span class="std std-ref">Algorithm_Lateral</span></a> containing the steering wheel angle.
Accelerator pedal position, brake pedal position and the currently engaged gear are fetched from the signal sent by the longitudinal dynamics module  <a class="reference internal" href="algorithm_longitudinal.html#algorithm-longitudinal"><span class="std std-ref">Algorithm_Longitudinal</span></a>.
The module is using these inputs and the vehicle parameters from <a class="reference internal" href="../../../advanced_topics/simulator/agent_components.html#parameters-vehicle"><span class="std std-ref">Parameters_Vehicle</span></a> to determine the resulting vehicle speed, yaw angle and absolute position in the road coordinate system.
The calculated values are passed on to the simulation framework/WorldObjectInterface.</p>
<section id="overview-of-the-module-s-functionalities">
<h2>Overview of the module’s functionalities<a class="headerlink" href="#overview-of-the-module-s-functionalities" title="Link to this heading"></a></h2>
<section id="longitudinal-dynamics">
<h3>Longitudinal dynamics<a class="headerlink" href="#longitudinal-dynamics" title="Link to this heading"></a></h3>
<p>The core element of all longitudinal calculations in this model are speed and acceleration. To determine the change of speed <img class="math" src="../../../_images/math/bee30f2cce9bda089aca48016006f43c7a1a00ab.png" alt="\Delta v"/> and the vehicles velocity <img class="math" src="../../../_images/math/a4c9a91b43ea371c8bcbd8c0401c992fa26de3d6.png" alt="v_{act_{i}}"/> of the current time step <img class="math" src="../../../_images/math/5aa339d4daf45a810dda332e3c80a0698e526e04.png" alt="i"/> the actual acceleration <img class="math" src="../../../_images/math/7b0abc6d78537d753de9943b9e76fa3301cbb12d.png" alt="a_{act}"/> has to be known.</p>
<p>The module uses a simplified longitudinal dynamics model e.g. it doesn’t factor in rotational inertias.</p>
<p><img class="math" src="../../../_images/math/7b0abc6d78537d753de9943b9e76fa3301cbb12d.png" alt="a_{act}"/> is dependend on the state variables and parameters shown in table 1.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Meaning</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Source</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/39f561d2298a2b2d3568abd7127f5af5cc75c1d7.png" alt="v_{act_{i-1}}"/></p></td>
<td><p>currently saved velocity of agent</p></td>
<td><p>m/s</p></td>
<td><p>WorldObjectInterface</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/5c9798f1510af6753c9eb7b2c5d58b140b69f161.png" alt="pos_{actuator}"/></p></td>
<td><p>position of accelerator/brake pedal</p></td>
<td></td>
<td><p>Algorithm_Longitudinal</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/e6de55aefd90417b1eeeeca680f4de59c48f92d2.png" alt="gear"/></p></td>
<td><p>chosen gear</p></td>
<td></td>
<td><p>Algorithm_Longitudinal</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/73c99fa583ee6f327c55a4cab30cf8f2fb882b6d.png" alt="i_{g} (gear)"/></p></td>
<td><p>gear ratio of current gear</p></td>
<td></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/27e857287a96f2b9a75e247a301de99d8abcbcaf.png" alt="i_{a}"/></p></td>
<td><p>gear ratio of axle</p></td>
<td></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/></p></td>
<td><p>maximum torque of the vehicle engine</p></td>
<td><p>Nm</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/de3b7384cfeaffe57a5f76636b9bb260f64cc2ad.png" alt="n_{eng,max}"/></p></td>
<td><p>maximum engine speed</p></td>
<td><p>1/min</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/d84bc4f13818666efe972485ffa26ce9163877a0.png" alt="n_{eng,min}"/></p></td>
<td><p>minimum engine speed</p></td>
<td><p>1/min</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/37e8317b2e01ed1fe34f29869ff8f5d2cdfa78eb.png" alt="r_{stat}"/></p></td>
<td><p>static wheel radius</p></td>
<td><p>m</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/91d00c99266d7225ea2e8cc6f4ee54e734da9323.png" alt="m_{vehicle}"/></p></td>
<td><p>vehicle mass</p></td>
<td><p>kg</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/880b25263bdfd625f9e5c24adabbc774dd57fcb8.png" alt="c_{W}"/></p></td>
<td><p>air drag coefficient</p></td>
<td></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/83ec55125f12779059d3ff3c74a47aeea3399c26.png" alt="c_{R}"/></p></td>
<td><p>rolling resistance tire</p></td>
<td></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/afa636aa8aff638847a1b0215abddcd70e3f75fc.png" alt="A_{proj}"/></p></td>
<td><p>front surface</p></td>
<td><p>m²</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
</tbody>
</table>
<p>First variables are used to calculate the current engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> .
To do so the speed of the wheels <img class="math" src="../../../_images/math/8a61447e565069614e8fb432e81f2ff844b08063.png" alt="n_{wheel}"/> is determined via the vehicle velocity and static wheel radius:</p>
<div class="math">
<p><img src="../../../_images/math/c6fe88e7f81a21f602311d08ad53cad221819c17.png" alt="n_{wheel} = \frac{v_{act_{i-1}}}{r_{stat}} \cdot \frac{60}{2 \cdot \pi}"/></p>
</div><p>The powertrain model in the following image is used to further derive the engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> using the gear ratio <img class="math" src="../../../_images/math/73c99fa583ee6f327c55a4cab30cf8f2fb882b6d.png" alt="i_{g} (gear)"/> of the currently engaged gear and axle ratio <img class="math" src="../../../_images/math/27e857287a96f2b9a75e247a301de99d8abcbcaf.png" alt="i_{a}"/> .</p>
<figure class="align-default" id="id1">
<span id="image-powertrainmodel2"></span><img alt="Illustration of the powertrain model and its parameters and state variables" src="../../../_images/PowertrainModel.svg" /><figcaption>
<p><span class="caption-text">Illustration of the powertrain model and its parameters and state variables</span><a class="headerlink" href="#id1" title="Link to this image"></a></p>
</figcaption>
</figure>
<div class="math">
<p><img src="../../../_images/math/186ca8cd801e8f6918af48eb6a945071e28a2ae0.png" alt="n_{eng} = n_{wheel} \cdot i_{a} \cdot i_{g} (gear)"/></p>
</div><p>The maximum torque <img class="math" src="../../../_images/math/3e4e0d087096eb420c02ba6cc2b4197ff56a209e.png" alt="M_{eng,max} (n_{eng})"/> at the current engine speed is determined using the engine torque map shown in the following image:</p>
<figure class="align-default" id="id2">
<img alt="Simplified Engine Map" src="../../../_images/EngineMapCalculated.svg" /><figcaption>
<p><span class="caption-text">Simplified Engine Map</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>At this point the module differentiates between deceleration and acceleration by checking whether the value of <img class="math" src="../../../_images/math/5c9798f1510af6753c9eb7b2c5d58b140b69f161.png" alt="pos_{actuator}"/> is positive or negative.
Negative values indicate the use of the brake pedal between 0-100% while positive values represent the use of the accelerator pedal.</p>
<p><strong>Driving resistance:</strong> There are driving resistances to be considered during the drive due to the rolling resistance of tires and air resistance which
could be calculated according to the follwing relations in fluid mechanics, where <img class="math" src="../../../_images/math/bb66f0561aa819e3a61f40b57423779d4449ee7b.png" alt="\rho_{air}"/> stands for air density in <img class="math" src="../../../_images/math/572e08c231b6275e31637c1762f65228f6814965.png" alt="kg / m^3"/> :</p>
<div class="math">
<p><img src="../../../_images/math/5d85248d3b87830ed3c7ef892134340a1814df3f.png" alt="a_{AirDrag} = - \frac{\rho_{air} \cdot c_{w} \cdot A_{proj} \cdot v_{act_{i-a}}^2}{2 \cdot m_{vehicle}}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/9e843b243e089427f0f03e68f6c20339afaff026.png" alt="a_{RollingDrag} = c_{R} \cdot 9.81 \frac{m}{s^2}"/></p>
</div><p>The rolling resistance of vehicle is currently set as a dummy value (0.0125), because the related value is not in the catalog of vehicle models yet and
therefore it still can not be tapped in interface.</p>
<p><strong>Decelerating:</strong> When decelerating <img class="math" src="../../../_images/math/7b0abc6d78537d753de9943b9e76fa3301cbb12d.png" alt="a_{act}"/> is the sum of the acceleration resulting from engine drag <img class="math" src="../../../_images/math/ee2ba61fbaf6c9b13c767d5736b69aacb3651125.png" alt="a_{drag}"/> and acceleration from braking <img class="math" src="../../../_images/math/e8de268f33225ec875a9286c75c8a9db2eb8a11a.png" alt="a_{brake}"/> .
Whenever the driver is braking the module assumes that the engine is dragging with a moment equal to 10% of the maximum torque at the current engine speed.</p>
<div class="math">
<p><img src="../../../_images/math/a9f707ea9d502e5790314de3e761f5a0e70c8517.png" alt="M_{drag}(n_{eng}) = - 0.1 \cdot M_{eng,max}(n_{eng})"/></p>
</div><div class="math">
<p><img src="../../../_images/math/894013d346d3f6084c024a5242ef0348bffe9045.png" alt="M_{wheel} = \frac{M_{drag}(n_{eng})}{i_{a} \cdot i_{g}(gear)}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/0ae69fbf18a11201f8a93d3bc6a3122ebf6e8ac6.png" alt="F_{wheel} = \frac{M_{wheel}}{r_{stat}}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/d947549fa7cd5a3b90c765827234dd49051b9f86.png" alt="a_{drag} = \frac{F_{wheel}}{m_{vehicle}}"/></p>
</div><p>The maximum braking deceleration is set to <img class="math" src="../../../_images/math/37111a2184c2be43f7b3fe1e0e04c07b4e6be554.png" alt="a_{brake,max} = 9.81 m/s^2"/>. The actual braking power is proportional to the position of the braking pedal.</p>
<div class="math">
<p><img src="../../../_images/math/060c673f214ca23089ee3cc239773684631c3399.png" alt="a_{brake} = pos_{actuator} \cdot a_{brake,max}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/f8d7df9afad3166f2b0384393c96c1b9ca1ccd73.png" alt="a_{act} = a_{drag} + a_{brake}"/></p>
</div><p><strong>Acceleration:</strong>  When the driver applies pressure on the accelerator the applied engine torque <img class="math" src="../../../_images/math/bfb515fe7446f9459350a2aee09a4a80bff7a857.png" alt="M_{eng,act}"/> is calculated as proportional to the accelerator pedal position and the span between engine drag and maximum engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/>(<img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> ) at the current engine speed.</p>
<div class="math">
<p><img src="../../../_images/math/24b413265db20d60d79af3a8b4f014d54dd6fbfa.png" alt="M_{eng}(n_{eng}) = M_{drag}(n_eng) + pos_{actuator}(M_{eng,max}(n_{eng}) - M_{drag}(n_{eng}))"/></p>
</div><div class="math">
<p><img src="../../../_images/math/e67ebc69b4822d8b0a9ac32a5e44bd412dc4530d.png" alt="M_{wheel} = \frac{M_{eng,act}}{i_{a} \cdot i_{g}(gear)}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/6626abca692e313e86ca6d9648b1a44848413f18.png" alt="F_{wheel} = \frac{M_{eng,act}}{r_{stat}}"/></p>
</div><div class="math">
<p><img src="../../../_images/math/b344d51cc9ada34a9dda96ea1d74c8cd4cfd40fb.png" alt="a_{act} = \frac{F_{wheel}}{m_{vehicle}}"/></p>
</div><p>Once the acceleration of the vehicle is known the change in velocity is determined by its discrete time integral.</p>
<div class="math">
<p><img src="../../../_images/math/9988102bf519586a1a00784b7bd8270af26d2f19.png" alt="\Delta v = a_{act} \cdot t_{cycle}"/></p>
</div><p>The sum of the previous velocity and change in velocity result in the actual vehicle velocity of the current time step:</p>
<div class="math">
<p><img src="../../../_images/math/a66c0776e2797799b3482188a68ea464966c2f2e.png" alt="v_{act_{i}} = v_{act_{i-1}} + \Delta v"/></p>
</div></section>
<section id="lateral-dynamics">
<h3>Lateral dynamics<a class="headerlink" href="#lateral-dynamics" title="Link to this heading"></a></h3>
<p>The lateral dynamics model is based on the Ackermann model which reduces the steering kinematics to a single surrogate front wheel. Considering the relatively small steering angles when driving on the highway this simplification is deemed suitable.
The heading is updated using the previous heading and the change in yaw due to the steering wheel angle which is converted into a yaw rate using the simplified Ackermann model shown in the following image.</p>
<figure class="align-default" id="id3">
<span id="image-ackermannmodel"></span><img alt="Illustration of the Ackermann model" src="../../../_images/AckermannModel.svg" /><figcaption>
<p><span class="caption-text">Illustration of the Ackermann model</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Meaning</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Source</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/264888dd4a4ab3d816ed5c325af60a02201fb97d.png" alt="\delta_{h}"/></p></td>
<td><p>steering wheel angle</p></td>
<td><p>rad</p></td>
<td><p>Algorithm_Lateral</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/33e5a161c226746b5f858520b66ab3b727990525.png" alt="\Phi_{act_{i-1}}"/></p></td>
<td><p>heading at previous time step</p></td>
<td><p>rad</p></td>
<td><p>WorldObjectInterface</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/4b005afb1bbdb9c3e7f2e6ae503ab9b842b73950.png" alt="i_{s}"/></p></td>
<td><p>steering ratio</p></td>
<td></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/3789a783f205339f47c886c78ba14bc944845b91.png" alt="l_{wheelbase}"/></p></td>
<td><p>wheelbase</p></td>
<td><p>m</p></td>
<td><p>vehicleModelParameters</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/82f8146372613edd07fa9be8b9227bdde1c42ac4.png" alt="\Delta s"/></p></td>
<td><p>distance travelled since last time step</p></td>
<td><p>m</p></td>
<td><p>previously calculated in the module</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/1e9a3c535b3949ccd3eb83a4d5d12930474263ff.png" alt="t_{cycle}"/></p></td>
<td><p>cycle time</p></td>
<td><p>ms</p></td>
<td><p>ModelInterface</p></td>
</tr>
</tbody>
</table>
<p>The steering wheel angle <img class="math" src="../../../_images/math/264888dd4a4ab3d816ed5c325af60a02201fb97d.png" alt="\delta_{h}"/> is proportional to the front wheel angle <img class="math" src="../../../_images/math/652b9d8b65c10aed0fdcdbde47396c879ed5bd33.png" alt="\delta"/> :</p>
<div class="math">
<p><img src="../../../_images/math/424c1a175a5c76c81deb6e4042c75f50e956dd11.png" alt="\delta = \frac{\delta_{h}}{i_{s}}"/></p>
</div><p>The Ackermann model provides the geometric connection between the front wheel angle and the resulting curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> :</p>
<div class="math">
<p><img src="../../../_images/math/815f71b583a7c8c8849b594c4c8457f3d9d1a3de.png" alt="\kappa = \frac{tan(\delta)}{l_{wheelbase}}"/></p>
</div><p>The combination of curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> and driven distance at that curvature <img class="math" src="../../../_images/math/82f8146372613edd07fa9be8b9227bdde1c42ac4.png" alt="\Delta s"/> result in the change of the heading <img class="math" src="../../../_images/math/2de70bff0cd28ce132a5b2bc1af61ea0952a801a.png" alt="\Delta \Phi"/>:</p>
<div class="math">
<p><img src="../../../_images/math/d74a416e1db39b7b85110d7ae6ef18db4883bdb9.png" alt="\Delta \Phi = atan(\kappa \cdot \Delta s)"/></p>
</div><p>The new heading <img class="math" src="../../../_images/math/a4012f826966de9f110274ceb2a787af289d6302.png" alt="\Phi_{act_{i}}"/> is the old heading <img class="math" src="../../../_images/math/409d43055a295e61738c90074520ffeedaba02c6.png" alt="\Phi_{act{i-1}}"/> plus the previously calculated change in heading <img class="math" src="../../../_images/math/2de70bff0cd28ce132a5b2bc1af61ea0952a801a.png" alt="\Delta \Phi"/> :</p>
<div class="math">
<p><img src="../../../_images/math/fb3ac93e4fcdd8aa908eaaf9e6ee33da73961444.png" alt="\Phi_{act_{i}} = \Phi_{act_{i-1}} + \Delta \Phi"/></p>
</div></section>
<section id="updating-position">
<h3>Updating position<a class="headerlink" href="#updating-position" title="Link to this heading"></a></h3>
<p>Once the new vehicle speed <img class="math" src="../../../_images/math/a4c9a91b43ea371c8bcbd8c0401c992fa26de3d6.png" alt="v_{act_{i}}"/> is determined the distance travelled during the last timestep <img class="math" src="../../../_images/math/82f8146372613edd07fa9be8b9227bdde1c42ac4.png" alt="\Delta s"/> is determined:</p>
<div class="math">
<p><img src="../../../_images/math/27768e5c81b3213969e180c799ad3fe899393aae.png" alt="\Delta s = v_{act_{i}} \cdot t_{cycle}"/></p>
</div><p>Using the actual vehicle yaw angle in the road coordinate <img class="math" src="../../../_images/math/33e5a161c226746b5f858520b66ab3b727990525.png" alt="\Phi_{act_{i-1}}"/> the vehicles new x- and y-coordinates are calculated:</p>
<div class="math">
<p><img src="../../../_images/math/61190de62458a3f64f789d9e487b86686c3089a3.png" alt="x_{agent_{i}} = x_{agent_{i-1}} + \Delta s \cdot cos(\Phi_{act_{i-1}})"/></p>
</div><div class="math">
<p><img src="../../../_images/math/8cc9781565d5e94551e510e5227826abb62d8fbf.png" alt="y_{agent_{i}} = y_{agent_{i-1}} + \Delta s \cdot sin(\Phi_{act_{i-1}})"/></p>
</div></section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="driver.html" class="btn btn-neutral float-left" title="Driver" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="dynamics_scenario.html" class="btn btn-neutral float-right" title="Dynamics_Scenario" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>